
declare variable $inputOffset as xs:integer external := 0;
declare function missing-edges-to-singular($json){
  let $n := max($json?*?*) + 1
  return (
  x"ring r = 0,({join( (
    (1 to $n) ! ("L" ||  .),
    for $i in 1 to $n, $j in 1 to $n return x"s{$i}s{$j}"
  ), ",")}),dp;",
  $json ! (
    x"""input {$inputOffset + position()}: {serialize-json(.)}"";",
    "groebner(ideal(" ||
    join(
      for $edge in .?* 
      let $a := min($edge?*)
      let $b := max($edge?*)
      return if ($a = 0) then x"s{1}s{$b + 1} - L{$b}*s{1}s{$b}"
      else x"L{$a}*L{$b}*s{$a}s{$b}-L{$a}*s{$a}s{$b+1}-L{$b}*s{$a+1}s{$b}+s{$a+1}s{$b+1}"
  (:e.g.:    [1,3] to  L1*L3*s13-L1*s14-L3*s23+s24 :)
      , ", "
    ) || "));"
  ))
};

declare function present-edges-to-missing-edges($node-count, $edges){

  $edges ! array {
    let $edges := .?*
    let $existence-map := map:merge($edges ! map { min(.?*) || "x" || max(.?*): true() })
    for $a in 0 to $node-count - 1 
    for $b in $a + 1 to $node-count - 1 
    let $key := $a || "x" || $b
    where not($existence-map($key))
    return [$a, $b]
  }
};


declare function edges-to-singular($node-count, $edges){
  missing-edges-to-singular(present-edges-to-missing-edges($node-count, $edges))
};

(:missing-edge-json-to-singular([[0,1], [0,2], [1, 2], [1, 3], [2, 3]]):)

(:present-edges-to-missing-edges(3, [[1, 2], [0,1], [0,2]]):)

(:edges-to-singular(5, [[0, 1]]):)

missing-edges-to-singular(parse-json($raw)())


,

missing-edges-to-singular(present-edges-to-missing-edges(5, [[3,1],[3,0],[1,0],[0,2],[0,4]]))
